function Xproj = PCAProj(X, whichInd, Vout, mus, stds)
% function PCAProj(X, whichInd, Vout, mus, stds)
%
% Project the vectors in X onto Vout after using mus and 
% stds to normalize X.

[M, dummy] = size(X);

Xsm = X(:,whichInd);
Xzm = Xsm - ones(M,1) * mus;
Xzms = Xzm ./ (ones(M,1) * stds);

Xproj = Xzms * Vout;
disp([num2str(round(1000*sum(sum((Xproj').^2))/sum(sum((Xzms').^2)))/10) '% of energy retained in projection (really only a valid interpretation for PCA)'])
