% for official_partitions
load ~/Documents/cs229/ourdata/Brazil/partitions.mat

% whichPart should be equal to either 1, 2, 3, 4, or 5
% It details tells which partition should be used for testing.

errMetrics = [];
allWts = [];
for l=1; %1:length(nmq_cell),
    %[X,Y] = make_large_X(nm_cell{l}, nmq_cell{l});

    parts = official_partitions{l};
    testInd = parts{whichPart};
    trainInd = [];
    for i=1:5,
      if not(i==whichPart)
	trainInd = [trainInd parts{i}];
      end
    end

    %trainInd = trainInd(1:10);
    %testInd = testInd(1:3);
    
    % Precompensate for the groove template bias
    beats = 0:1/8:3.875;
    [timbs, timbMt, mtMat] = estimateMultiTimbGrooveTemplates(nm_cell{l}, nmq_cell{l}, trainInd, beats);
    [Ytrain, trainGTErrVar] = compensateByMultiTimbGrooveTemplates(nm_cell{l}, nmq_cell{l}, trainInd, beats, timbs, timbMt, mtMat);
    [Ytest, testGTErrVar] = compensateByMultiTimbGrooveTemplates(nm_cell{l}, nmq_cell{l}, testInd, beats, timbs, timbMt, mtMat);


    % Create a basis using the training vectors
    pcaDim = 12;
    Xtrain = X(trainInd,:);
    Vout = [];
    [mDim, nDim] = size(Vout);
    % Repeat in case ICA is having problems ...
    while (not(or(mDim == pcaDim, nDim == pcaDim)))
      [whichInd, Vout, Xmus, Xstds, Htrain] = doPCA(Xtrain, pcaDim, 0, 1); %...
      % 3rd argument is 0-->PCA, otherwise it uses ICA from FastICA
      [mDim, nDim] = size(Vout);
    end

    drawnow
    %pause

    % Use the same basis (Vout) to project the test vectors
    Xtest = X(testInd,:);
    Htest = PCAProj(Xtest, whichInd, Vout, Xmus, Xstds);


    % Create other features
    [F] = make_F(nmq_cell{l},2);
    Ftrain = F(trainInd,:);
    Ftest = F(testInd,:);

    [FtrainNorm, Fmus, Fstds, whichCols] = findOurNorm(Ftrain);
    [FtestNorm] = applyOurNorm(Ftest, Fmus, Fstds, whichCols);


    % Concatenate all of the features
    Gtrain = [FtrainNorm Htrain];
    Gtest = [FtestNorm Htest];
    %Gtrain = FtrainNorm;
    %Gtest = FtestNorm;


    [errMetric, wts] = doGP(Htrain, Ytrain, Htest, Ytest)
    allWts = [allWts; wts'];
    errMetrics = [errMetrics; errMetric];

    save delme
end
