% For testing using models for individual timbres
%
% The PCA bases are obtained using ALL of the brazilian data,
% while the training examples pertain only to the particular rhythm.


% for official_partitions
load ~/Documents/cs229/ourdata/Brazil/partitions.mat

% If there are fewer than 20 training examples, give up.
minTraining = 20;

% use this timbre
timbre = 42;

if (0)
    p=1;
    X = [];
    Y = [];
    for l=1:length(nmq_cell),
        ind =  find(nmq_cell{l}(:,4) == timbre);
        [Xinc,Yinc] = make_large_X(nm_cell{l}(ind,:), nmq_cell{l}(ind,:));
        X = [X; Xinc];
        Y = [Y; Yinc];
    end
    PCAX = X;

    % Create a basis using ALL of the training vectors
    pcaDim = 5;
    [whichInd, Vout, Xmus, Xstds] = doPCA(PCAX, pcaDim,1);
    drawnow
end

errMetrics = [];
allWts = [];
for l=1:length(nmq_cell),
    ind = find(nmq_cell{l}(:,4) == timbre);
    parts = official_partitions{l};
    oldpart1 = parts{1};
    disp(['Testing on ' brazilrhythmnames{l} ' which has ' num2str(length(ind)) ' onsets'])

    %If we use all of the data for generating features
    %[X,Y] = make_large_X(nm_cell{l}(ind,:), nmq_cell{l}(ind,:));

    % If we only use the given timbre for finding data instead
    [X,Y] = make_large_X(nm_cell{l}(ind,:), nmq_cell{l}(ind,:));
    for i=1:5,       % need to remap the partitions so that they have the
        aPart = [];  % correct indices
        for j=1:length(ind),
            if length(find(ind(j) == parts{i})) > 0
                aPart = [aPart j];
            end
        end
        parts{i} = aPart;
    end
    testInd = parts{1};
    trainInd = [parts{2} parts{3} parts{4} parts{5}];

    Xtrain = X(trainInd,:);
    Xtest = X(testInd,:);


    checkXY = 0;
    if (checkXY)
        [Xfull,Yfull] = make_large_X(nm_cell{l}, nmq_cell{l});

        % Check that all of the microtimings are
        % correctly aligned between the two vectors
        Yfull(ind(testInd)) - Y(testInd)
        pause

        % Check that they are also the right timbre!
        nm_cell{l}(ind(1:15),:)
        pause
    end


    length(trainInd)
    if (length(trainInd) <= minTraining)
        % hack for now to enable skipping over examples that don't have
        % enough data
        disp(['WARNING:  There may be a problem because length(trainInd)==' num2str(length(trainInd))])
    end
    try

        % Use the same basis (Vout) to project the test vectors
        Htrain = PCAProj(Xtrain, whichInd, Vout, Xmus, Xstds);
        Htest = PCAProj(Xtest, whichInd, Vout, Xmus, Xstds);

        % Create other features
        [F] = make_F(escola_nmq);
        Ftrain = F(trainInd,1:5);  % need to eliminate the sixth column now!
        Ftest = F(testInd,1:5);

        [FtrainNorm, Fmus, Fstds] = findOurNorm(Ftrain);
        [FtestNorm] = applyOurNorm(Ftest, Fmus, Fstds);

        % Concatenate all of the features
        Gtrain = [FtrainNorm Htrain];
        Gtest = [FtestNorm Htest];
        %Gtrain = FtrainNorm;    % if we don't use the PCA data
        %Gtest = FtestNorm;

        Ytrain = Y(trainInd);
        Ytest = Y(testInd);

        [errMetric, wts] = doGP(Gtrain, Y(trainInd), Gtest, Y(testInd)); %, 0, prevWts);
        errMetric
    catch
        disp(lasterr)

        % On failure, insert infinite values into the output
        errMetric = -inf*ones(1,7);
        wts = -inf*ones(pcaDim + 5 + 2,1);
    end


    allWts = [allWts; wts'];
    errMetrics = [errMetrics; errMetric];

    save delme
end


