function [nm,k] = chopnm(nmat,minbeatsbetween)
% [nm,k] = chopnm(nmat,minbeatsbetween)
%
% Chops a single notematrix containing multiple patterns separated by
% at least MINBEATSBETWEEN beats into k separate notematrices which are
% stored in a cell matrix.
%
% chopnm subtracts off integer multiples of beats such that the first beat
% of the pattern begins as closely to 0 as possible.  The times are
% normalized accordingly by using the tempo from GETTEMPO.


tothits = 0;
[m,n] = size(nmat);
i = 1;
lastonset = -inf;    % so that the first elements will be included in a notematrix
k = 0;


% start new nmattmp
nmattmp = [];
j = 1;
while (i <= m)
    if or((nmat(i,1) - lastonset) > minbeatsbetween,i==m)
        % save old nmattmp if it exists
        if (k > 0)
            if (i==m)
                % add the VERY LAST onset to nmattmp
                nmattmp(j,1:n) = nmat(i,1:n);
                j = j + 1;
            end

            % Normalize the starting onset times in beats and seconds
            extrabeats = round(nmattmp(1,1));
            nmattmp(:,1) = nmattmp(:,1) - extrabeats;
            nmattmp(:,n-1) = nmattmp(:,n-1) - extrabeats/gettempo(nmat)*60;

            matr(k) = {nmattmp};
            tothits = tothits + length(nmattmp(:,1));
            
        end
        k = k + 1;


        % start new nmattmp
        if (i<m)
            nmattmp = [];
            j = 1;
        end
    end

    % add next hit to nmattmp
    nmattmp(j,1:n) = nmat(i,1:n);
    j = j + 1;

    lastonset = nmat(i,1);
    i = i + 1;
end


nm = matr;
k = length(nm);
if (tothits ~= m)
    m
    disp(sprintf('Total # of onsets: %d',tothits))
    error('Something doesnt make sense!')
end