function [Y, totErr] = compensateByMultiTimbGrooveTemplates(nm, nmq, whichind, beats, timbs, timbMt, mtMat)
% Uses the multi-timbreal groove template stored in timbMt and mtMat to see
% what the error variance would be if only the multi-timbreal groove
% template were used to estimate the microtimings.
%
% A Y-vector is also output from which the bias has been removed
% according to the multi-timbreal groove template.


nmqtest = nmq(whichind,:);
nmtest = nm(whichind,:);

totErr = 0;
[M,N] = size(nmqtest);
Y = zeros(M,1);
for m=1:M,
    timbInd = find(timbs == nmqtest(m,4));
    beatInd = find(beats == mod(nmqtest(m,1),4));

    this_actual = nmtest(m,1) - nmqtest(m,1);
    this_guess = mtMat(beatInd, timbInd);
    Y(m) = this_actual - this_guess;
    %disp([this_actual this_guess])

    totErr = totErr + (this_actual - this_guess)^2;
end

totErr = totErr / M;