% learningCurves
%
% Generate simple learning curves for GP to see if
% we're having problems with bias or variance.


tstPct = linspace(0.9,0.2,25);
ind = 1;
trainErrs = [];
testErrs = [];
for t=tstPct,
    notdone = 1;

    [nmout matches distances errors] = simpleKRR('notedistance', 'Brazil','ESCOLA',0,2,tstPct);
    [trainErr, testErr] = testgp(t);
 

    trainErrs(ind) = trainErr
    testErrs(ind) = testErr

    % Update the plot live ...
    figure(4)
    hold off
    plot(tstPct(1:ind), trainErrs);
    hold on
    plot(tstPct(1:ind), testErrs,'r');
    legend('Training error','Test error')
    drawnow
    xlabel('Percent of data used for testing')
    ylabel('Error variance')

    ind = ind + 1
end



% Just testing on Escola ...
ind = st;
trainErrsEsc = [];
testErrsEsc = [];
for t=tstPct(st:nd),
    notdone = 1;
    % Repeat until success ...
    while (notdone)
        try
            [trainErr, testErr] = testgp(t, wts(:,ind));
            notdone = 0;
        catch
            lasterr
        end
    end

    trainErrsEsc(ind) = trainErr
    testErrsEsc(ind) = testErr

    
    % Update the plot live ...
    figure(5)
    hold off
    plot(tstPct(st:ind), trainErrsEsc(st:ind));
    hold on
    plot(tstPct(st:ind), testErrsEsc(st:ind),'r');
    legend('Training error','Test error')
    drawnow
    xlabel('Percent of data used for testing')
    ylabel('Error variance')

        
    ind = ind + 1
end






st = 5;
nd = 24;
wts1 = mean(ewts(:,st:nd)')';
wts2 = exp(mean(log(ewts(:,st:nd))')');
avgNum = 100;
for i = 16:avgNum,
    [trainErr, testErr] = testgp(.97, wts1);
    testOne(i) = testErr;
    
    [trainErr, testErr] = testgp(.97, wts2);
    testTwo(i) = testErr;
end