function DM = make_distance_matrix(distMeasure, nmq, dataset, ...
				   rhythmname, usableInd)

fname = ['~/Documents/cs229/ourdata/' dataset '/Distances/' ...
	 rhythmname '-' distMeasure '.mat'];
disp(['Accessing the file ' fname])

global xnmq ynmq
xnmq = nmq;
ynmq = nmq;

n = size(nmq, 1)

if (dataset == 'Brazil')
  ind_is_bogus = zeros(1, n)
else
  % Reggae, so need to know usable indices
  if nargin < 5
    error('Need usableInd to make reggae distance matrix!')
  end

  ind_is_bogus = ones(1, n);
  ind_is_bogus(usableInd) = zeros(1,length(usableInd));
end

DM = zeros(n, n);

for i=1:n
  if (ind_is_bogus(i))
    DM(i,i) = inf;
  end
  for j=i+1:n
    if (or(ind_is_bogus(i), ind_is_bogus(j)))
      d = inf;
    else
      d = feval(distMeasure,i,j);
    end
    DM(i,j) = d;
  end
  disp([num2str(round(100*(i/n))) '% done'])
end
 
% Convert to symmetric:
DM = DM + DM';

save(fname,'DM', 'nmq', 'rhythmname');
