function d = notedistance(xi,yi)

global xnmq ynmq T 

beatDistPenalty = 75;
wrongTimbrePenalty = 200;
% rest of penalty due to varying timbres being played 
% on the sames beats is on the order of 25 to 50


% Check that we're not too close to the beginning or the end of the
% notematrix.  In that case, the distance is infinite.
maxBeatWindowDist = 1;
if or(xnmq(xi,1) < maxBeatWindowDist, xnmq(length(xnmq),1)-xnmq(xi,1) < maxBeatWindowDist)
    d = inf;
    return
end

% Estimate distance due to differences in the bar positions
x_barpos = mod(xnmq(xi,1), 4);
y_barpos = mod(ynmq(yi,1), 4);
if or(size(x_barpos) ~= [1 1], size(y_barpos) ~= [1 1])
    disp('fishy')
end
d = beatDistPenalty*beatdistance(x_barpos, y_barpos);

% Heavily penalize timbres that are different
if (xnmq(xi,4) ~= ynmq(yi,4))
    d = d + wrongTimbrePenalty;
end

% Increase distance due to timbreal distances between adjacent onsets
xOffset = xnmq(xi,1);
yOffset = ynmq(yi,1);
xWindInd = find(abs(xnmq(:,1) - xOffset) <= maxBeatWindowDist);
yWindInd = find(abs(ynmq(:,1) - yOffset) <= maxBeatWindowDist);
rel_beats = unique([[xnmq(xWindInd,1) - xOffset]; [ynmq(yWindInd,1) - yOffset]]);

dadd = d;
missingPenalty = 2;
for b=rel_beats',
    xInd = find(xnmq(xWindInd,1) - xOffset == b);
    yInd = find(ynmq(yWindInd,1) - yOffset == b);
    xL = length(xInd);
    yL = length(yInd);

    if or(xL == 0, yL == 0)
        % Double the penalty for the case that one note offset doesn't
        % have any onsets at all ...
        d = d + missingPenalty*(xL + yL);
    else
        % (Don't worry about flams for now)

        for cxInd = xWindInd(xInd)',
            % Compare this timbre with the other timbres in ynmq(yInd)
            xTmb = xnmq(cxInd,4);

            locDist = inf;
            for cyInd = yWindInd(yInd)',
                yTmb = ynmq(cyInd,4);
                %disp(sprintf('%d %d',xTmb,yTmb))
                locDist = min(locDist, T(xTmb, yTmb));

                % Other influences on the local distance
                % could be implemented here

            end
            %locDist
            d = d + locDist;
        end

        for cyInd = yWindInd(yInd)',
            % Compare this timbre with the other timbres in ynmq(yInd)
            yTmb = ynmq(cyInd,4);

            locDist = inf;
            for cxInd = xWindInd(xInd)',
                xTmb = xnmq(cxInd,4);
                %disp(sprintf('%d %d',xTmb,yTmb))
                locDist = min(locDist, T(yTmb, xTmb));

                % Other influences on the local distance
                % could be implemented here

            end
            %locDist
            d = d + locDist;

        end


        %if (locDist ~= 1)
        %    disp('stop')
        %end

        disp('')
        disp('')
    end

    % Repeat w.r.t. y so that the distance metric is symmetric


end

dadd = d - dadd;
