

% for official_partitions
load ~/Documents/cs229/ourdata/Brazil/partitions.mat

l = 2;    % for olodum

[X,Y] = make_large_X(nm_cell{l}, nmq_cell{l});  

parts = official_partitions{l};
testInd = parts{1};
trainInd = [parts{2} parts{3} parts{4} parts{5}];



% Create a basis using the training vectors
pcaDim = 5;
Xtrain = X(trainInd,:);
[whichInd, Vout, Xmus, Xstds, Htrain] = doPCA(Xtrain, pcaDim);

% Use the same basis (Vout) to project the test vectors
Xtest = X(testInd,:);
Htest = PCAProj(Xtest, whichInd, Vout, Xmus, Xstds);


% Create other features
[F] = make_F(escola_nmq);
Ftrain = F(trainInd,:);
Ftest = F(testInd,:);

[FtrainNorm, Fmus, Fstds] = findOurNorm(Ftrain);
[FtestNorm] = applyOurNorm(Ftest, Fmus, Fstds);


% Concatenate all of the features
Gtrain = [FtrainNorm Htrain];
Gtest = [FtestNorm Htest];
%Gtrain = FtrainNorm;
%Gtest = FtestNorm;

Ytrain = Y(trainInd);
Ytest = Y(testInd);

errMetrics = [];
allWts = [];

[M,N] = size(Gtrain);
[errMetric wts] = doGP(Gtrain, Y(trainInd), Gtest, Y(testInd), 1);
allWts = [allWts; wts'];
errMetrics = [errMetrics; errMetric];

for l=1:100,
  [errMetric wts] = doGP(Gtrain, Y(trainInd), Gtest, Y(testInd), 1, wts)
  allWts = [allWts; wts'];
  errMetrics = [errMetrics; errMetric];

save numiters
end


