function quantizedataset(dataset, newDurRatio)
% Quantize the onset times of all of the files
% in the dataset.


%[nm,name] = dir2coll(strcat(dataset,'/Chopped'));
indir = strcat(dataset,'/Chopped');
outdir = strcat(dataset,'/Quantized/');



k = 1;
fnames = [];
onsetRes = [];
if (dataset == '~/Documents/cs229/ourdata/Brazil')

    % Quantize each sequence according to the given onset resolution
    fnames =   {{'ESCOLA-1'}
                {'OLODUM-1'}
		{'SAMBAREG-1'}
		{'ROKBAHIA-1'}
		{'MARACANA-1'}
		{'PARTALTO-1'}
		{'SAMBAFNK-1'}
		{'AFOXE-1'}
		{'BAIAO-1'}};
    onsetRes = (1/16) * ones(1,9);
elseif (dataset == '~/Documents/cs229/ourdata/Reggae')
     disp('skank it!');

    prefixes = {'120MIX',
		 '80REG1',
		 '80REG2',
		 '80ROCK',
		 'LVRK1',
		 'LVRK2',
		 'SKAPATT'};
    fnames = {};

    for p = prefixes'
	pattern = [dataset '/Chopped/' char(p) '*']
        D=dir(pattern);

	for i = 1:length(D)
	    name = D(i).name;
	    withoutsuffix = name(1:length(name)-4);
	    fnames = {fnames{:}, withoutsuffix};
	end
    end

    onsetRes = (1/16) * ones(1, length(fnames));
end


K = length(onsetRes);
for k=1:K,
    disp(['Quantizing ' strcat(fnames{k},'.MID')]);
    [nm, nmq] = quantizesequence(strcat(char(fnames{k}),'.MID'),dataset,onsetRes(k),[],[],newDurRatio);

    nm_cell(k) = {nm};
    nmq_cell(k) = {nmq};

    writemidi(nmq,strcat(outdir,strcat(strcat(char(fnames{k}),'-Q'),'.MID')),10000,gettempo(nmq));
end


% Save also in MATLAB format to avoid losing any information
save(strcat(outdir,'/NoteMatrices.mat'),'nm_cell','nmq_cell','fnames','onsetRes')
