% These (global) variables are like the arguments to this script;
% they should already be defined:

if 0
  cd Documents/cs229/
  matlab -nojvm

  setpathccrma
  clear
  load_data
  search_KRR_paramspace
end

if 1
  factor_out_groove_template = 1;
  dostem = 1;
  officialPartitions = 1;
  randomNotes = 0;
  write_midi_sequences=0;
  mat_suffix = '';
  THEGENRE = 1;
  THERHYTHMNUMBER = 2;
  llow = log(10);
  lhigh = log(1000);
  step = (lhigh-llow)/5;
  

  svalues = exp([llow:step:lhigh]);
%  svalues = [svalues 10 100 1000];

%  num_lambda = 5;
% Min was 3 with the old "times 10" extra lambda value
 num_lambda = 3;

%  svalues = [100:100:1000];
%  svalues = 10 .^ [2:6];
%  svalues = [500:100:1500];
%  svalues = [100:100:1000];
end

% for genre = 1:2
for genre = THEGENRE
  if genre == 1
    dataset = 'Brazil'
    rhythmnames = brazilrhythmnames
    disp('obrigado');
  else
    dataset = 'Reggae'
    rhythmnames = reggaerhythmnames
    disp('irae');    
  end

% for rhythmNumber = 1
% for rhythmNumber = 1:length(rhythmnames)
for rhythmNumber = THERHYTHMNUMBER
  disp(' ');
  disp(' ');
  disp(' ');
  disp(' ');
  disp('**************************************************');

  whichrhythm = rhythmNumber;
  rhythmname = rhythmnames{whichrhythm}

  % "Y" = train, "X" = test
  global xnmq ynmq ynm
  if dataset == 'Brazil'
    xnmq = nmq_cell{rhythmNumber};
    ynmq = nmq_cell{rhythmNumber};
    ynm = nm_cell{rhythmNumber};
  else
    xnmq = nmq_reg_cell{rhythmNumber};
    ynmq = nmq_reg_cell{rhythmNumber};
    ynm = nm_reg_cell{rhythmNumber};
  end

  if factor_out_groove_template
    % We'll be overwriting ynm's microtimings with the
    % groove-template-subtracted-out values, so we need to save the
    % original values to do k-fold.
    ynm_orig = ynm;
  end

  
  distMeasure = 'notedistance';
  
  DMfname = ['~/Documents/cs229/ourdata/' dataset '/Distances/' ...
	     rhythmname '-' distMeasure '.mat'];
  disp(['Accessing the file ' DMfname])
  
  load(DMfname)
  
  sizeDM = size(DM)


  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Set up training data and test data
  
  if officialPartitions
    if dataset == 'Brazil'
      ind_cell = official_partitions{whichrhythm};
    elseif dataset == 'Reggae'
      ind_cell = official_partitions_reggae{whichrhythm};
    else
      error('Unrecognized dataset: no official partition');
    end
      
    k = length(ind_cell);
    
    xind_cell = cell(k,1);
    yind_cell = cell(k,1);
    
    for i = 1:k
      test = ind_cell{i};
      train = [];
      for j = 1:k
	if i~=j
	  train = [train ind_cell{j}];
	end
      end
      xind_cell{i} = test;
      yind_cell{i} = train;
      clear test train
    end
    
  else % not officialPartitions
    totalN = length(ynm);
    % totalN = 80;
    
    %% "Y" = training data
    %% "X" = new input
    
    xind = [];
    yind = [];
    
    disp('Throwing away first and last 20 notes because distance metric has')
    disp('issues with boundary conditions');
    usableIndices = 20:totalN-20;
    
    if randomNotes
      disp('Choosing random notes');
      for n=usableIndices
	if (rand > 0.7) 
	  xind = [xind; n];
	else
	  yind = [yind; n];
	end
      end
    else
      disp('Use last 70% as training data, rest as test data');
      cutoff = round(0.30 * length(usableIndices));
      xind = usableIndices(1:cutoff)';
      yind = usableIndices(cutoff+1:length(usableIndices))';
    end
    xind_cell = {xind};
    yind_cell = {yind};
  end
  





  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Set up variables to hold results of comparisons

  num_s = length(svalues)

  % errVarMatrix = zeros(num_s, num_lambda);
  squaredErrorSumMatrix = zeros(num_s, num_lambda);
  lambdaMatrix = zeros(num_s, num_lambda);
  % absErrAvgMatrix = zeros(num_s, num_lambda);
  absErrSumMatrix = zeros(num_s, num_lambda);
  totalCount = zeros(num_s, num_lambda);

  %  elapsedTimeMatrix = zeros(num_s, num_lambda);

  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  %% Try parameters

  num_trials = length(xind_cell);
  for trial = 1:num_trials
    xind = xind_cell{trial};
    yind = yind_cell{trial};
    train = yind;
    test = xind;
%    disp(['Training on ' num2str(length(yind)) ' notes, testing on ' ...
%	  num2str(length(xind)) ' notes.']);

    % Factor out groove template    
    if factor_out_groove_template    
      % Precompensate for the groove template bias
      beats = 0:1/8:3.875;
      [timbs, timbMt, mtMat] = ...
	 estimateMultiTimbGrooveTemplates(ynm_orig, ynmq, train, beats);

      [Ytrain, trainGTErrVar] = ...
	  compensateByMultiTimbGrooveTemplates(ynm_orig, ynmq, train, ...
					       beats, timbs, timbMt, ...
					       mtMat);
      ynm(train,1) = ynmq(train, 1) + Ytrain;

      disp ('just subtracted out the groove template');

%      [Ytest, testGTErrVar] = ...
%	  compensateByMultiTimbGrooveTemplates(nm_cell{l}, nmq_cell{l}, testInd, beats, timbs, timbMt, mtMat);

    end

    Ytest = ynm(test,1) - ynmq(test,1);
    true_devs = Ytest;

    for i = 1:length(svalues)
      i
      s = svalues(i)

      % Find eigenvalues to choose possible values of lambda

      phiTphi = exp(-((DM).^2)/2/s);
      indices_used = unique([train test]);
      phiTphi_used = phiTphi(indices_used, indices_used);
      e = eig(phiTphi_used);

      minlambda = max(0, -min(e) + 0.001);
      maxlambda = 5 * (max(e) - min(e));
%      maxlambda = minlambda*2;
  
%disp('before')
%      lambdastep = (maxlambda-minlambda) / (num_lambda-2);

%      lambdavalues = [minlambda:lambdastep:maxlambda, maxlambda*2]
%disp('after')

      lambdastep = (maxlambda-minlambda) / (num_lambda-1);
      lambdavalues = [minlambda:lambdastep:maxlambda]

%      disp('pause')
%      pause

      for j = 1:length(lambdavalues)
	j
	lambda = lambdavalues(j);

	tic
	YEst = KRR(test, train, DM, 0, s, lambda);
	elapsedtime = toc;

	if factor_out_groove_template
	  % Now put the groove template back in
	  YEst_template = ...
	      compensateByMultiTimbGrooveTemplates(xnmq, xnmq, test, beats, timbs, timbMt, -mtMat);
	  YEst = YEst + YEst_template;
	  disp('added groove template back in');
	end

	xnm = xnmq;
	xnm(test,1) = xnm(test,1) + YEst;

	elapsedTimeMatrix(i,j) = elapsedtime;

	errors = YEst - Ytest;

	% Put training data and output of our algorithm together into a sequence we can play
	% Start with a copy of the original sequence
	nmout = ynm;
	% Now replace all the test set times with the output of our algorithm
	nmout(xind) = xnm(xind);

	%% Output some statistics about how well we did
	n = length(errors)
	sumSquareError = sum(errors.^2);
	errVar = sumSquareError/n        % Variance of the error
	mtVar = sum(true_devs.^2)/n   % Variance of actual microtimings
	
	sumAbsErr = sum(abs(errors));
	absErrAvg = sumAbsErr/n
	absMtAvg = sum(abs(true_devs))/n
	
	squaredErrorSumMatrix(i,j) = squaredErrorSumMatrix(i,j) + ...
	    sumSquareError;
	absErrSumMatrix(i,j) = absErrSumMatrix(i,j) + sumAbsErr;
	totalCount(i,j) = totalCount(i,j) + n;



	%% Output some statistics about how well we did
	errVar = sum(errors.^2)/length(errors);        % Variance of the error
	mtVar = sum(true_devs.^2)/length(true_devs);   % Variance of actual microtimings

	disp(['errVar: ' num2str(errVar) ', mtVar: ' num2str(mtVar)]);
    
	absErrAvg = sum(abs(errors))/length(errors);
	absMtAvg = sum(abs(true_devs))/length(true_devs);

	lambdaMatrix(i,j) = lambda;
      end % lambdas
    end % s values
  end % trials



disp('****************************************************************************');

rhythmname
svalues
lambdaMatrix

errVarMatrix = squaredErrorSumMatrix ./ totalCount
absErrAvgMatrix = absErrSumMatrix ./ totalCount;

mtVar
[bestErrVar i j] = min2d(errVarMatrix)
bests = svalues(i)
bestlambda = lambdaMatrix(i,j)
correspondingAbsErrAvg = absErrAvgMatrix(i,j)


absMtAvg
[bestAbsErr i j] = min2d(absErrAvgMatrix)
bests = svalues(i)
bestlambda= lambdaMatrix(i,j)

save(['~/Documents/cs229/results/krr/paramspace_' rhythmname mat_suffix '.mat'] ...
     , 'errVarMatrix', 'absErrAvgMatrix', 'mtVar', 'bestErrVar', ...
	  'bests', 'bestlambda', 'rhythmname', 'svalues', 'lambdaMatrix');

end % rhythm number
end % genre

rhythmNumber

disp('Have a nice day!');

