% These (global) variables are like the arguments to this script;
% they should already be defined:

if 0
  cd Documents/cs229/
  matlab -nojvm

  setpathccrma
  clear
  load_data
  search_kNN_parameterspace
end


if 1
  dostem = 0;
  officialPartitions = 1;
  randomNotes = 0;
  write_midi_sequences=0;
  THEGENRE = 2;
  THERHYTHM = 3;
%  kvalues = [1 2 3 4 5 10:2:30 35:5:100 200 300 400 100000];
%  kvalues = [18];
  kvalues = [1000000];
  tauvalues = [8:2:30 40:10:100];
%  tauvalues = [40]
end


% for genre = 1:2
for genre = THEGENRE

  if genre == 1
    dataset = 'Brazil'
    rhythmnames = brazilrhythmnames
    disp('obrigado');
  else
    dataset = 'Reggae'
    rhythmnames = reggaerhythmnames
    disp('irae');    
  end

% for rhythmNumber = 1
% for rhythmNumber = 1:length(rhythmnames)
for rhythmNumber = THERHYTHM
  
  disp(' ');
  disp(' ');
  disp(' ');
  disp(' ');
  disp('**************************************************');

  whichrhythm = rhythmNumber;
  rhythmname = rhythmnames{whichrhythm}

  global xnmq ynmq ynm
  if dataset == 'Brazil'
    xnmq = nmq_cell{rhythmNumber};
    ynmq = nmq_cell{rhythmNumber};
    ynm = nm_cell{rhythmNumber};
  else
    xnmq = nmq_reg_cell{rhythmNumber};
    ynmq = nmq_reg_cell{rhythmNumber};
    ynm = nm_reg_cell{rhythmNumber};
  end
  
  distMeasure = 'notedistance';
  
  DMfname = ['~/Documents/cs229/ourdata/' dataset '/Distances/' ...
	     rhythmname '-' distMeasure '.mat'];
  disp(['Accessing the file ' DMfname])
  
  load(DMfname)
  
  sizeDM = size(DM)
  
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  % Set up training data and test data
  
  if officialPartitions
    if dataset == 'Brazil'
      ind_cell = official_partitions{whichrhythm};
    elseif dataset == 'Reggae'
      ind_cell = official_partitions_reggae{whichrhythm};
    else
      error('Unrecognized dataset: no official partition');
    end
      
    k = length(ind_cell);
    
    xind_cell = cell(k,1);
    yind_cell = cell(k,1);
    
    for i = 1:k
      test = ind_cell{i};
      train = [];
      for j = 1:k
	if i~=j
	  train = [train ind_cell{j}];
	end
      end
      xind_cell{i} = test;
      yind_cell{i} = train;
    end
    
  else % not officialPartitions
    totalN = length(ynm);
    % totalN = 80;
    
    %% "Y" = training data
    %% "X" = new input
    
    xind = [];
    yind = [];
    
    disp('Throwing away first and last 20 notes because distance metric has')
    disp('issues with boundary conditions');
    usableIndices = 20:totalN-20;
    
    if randomNotes
      disp('Choosing random notes');
      for n=usableIndices
	if (rand > 0.7) 
	  xind = [xind; n];
	else
	  yind = [yind; n];
	end
      end
    else
      disp('Use last 70% as training data, rest as test data');
      cutoff = round(0.30 * length(usableIndices));
      xind = usableIndices(1:cutoff)';
      yind = usableIndices(cutoff+1:length(usableIndices))';
    end
    xind_cell = {xind};
    yind_cell = {yind};
  end
  



  num_k = length(kvalues);
  num_tau = length(tauvalues);
  
  % errorMatrix = zeros(num_k, num_tau, length(xind));
  % devMatrix = zeros(num_k, num_tau, length(xind));
  % errVarMatrix = zeros(num_k, num_tau);
  squaredErrorSumMatrix = zeros(num_k, num_tau);
  % absErrAvgMatrix = zeros(num_k, num_tau);
  absErrSumMatrix = zeros(num_k, num_tau);
  totalCount = zeros(num_k, num_tau);
  
  
  %% Try parameters
  num_trials = length(xind_cell);

  alltrial_squaredErrorSumMatrix = zeros(num_k, num_tau);
  alltrial_absErrSumMatrix = zeros(num_k, num_tau);
  alltrial_count = 0;

  for trial = 1:num_trials

    xind = xind_cell{trial};
    yind = yind_cell{trial};
    
    disp(['Training on ' num2str(length(yind)) ' notes, testing on ' ...
	  num2str(length(xind)) ' notes.']);

    for i=1:num_k
      k = kvalues(i);
      for j = 1:num_tau
	tau = tauvalues(j);
	
	[xnm matches distances] = apply_kNN(xind, yind, k, tau, DM);
	
	% Check out how well we did
	output_devs = xnm(xind, 1) - xnmq(xind, 1);
	true_devs = ynm(xind, 1) - ynmq(xind, 1);
	
	% devMatrix(i, j, :) = output_devs;
	
	errors = (true_devs - output_devs);
	% errorMatrix(i, j, :) = errors;

	if dostem
	  figure();
	  stem(xind, true_devs, 'b');
	  hold on;
	  stem(xind, output_devs, 'r')
	  title('True microtimings (blue) vs KRR output (red)');
	  ylabel('Microtiming (beats)');
	  xlabel('Each note');
	end

	
	% Put training data and output of our algorithm together into a sequence we can play
	% Start with a copy of the original sequence
	nmout = ynm;
	% Now replace all the test set times with the output of our algorithm
	nmout(xind) = xnm(xind);
	
	%% Output some statistics about how well we did
	n = length(errors)
	sumSquareError = sum(errors.^2);
	errVar = sumSquareError/n;        % Variance of the error
	mtVar = sum(true_devs.^2)/n;   % Variance of actual microtimings
	
	sumAbsErr = sum(abs(errors));
	absErrAvg = sumAbsErr/n;
	absMtAvg = sum(abs(true_devs))/n;
	
	squaredErrorSumMatrix(i,j) = squaredErrorSumMatrix(i,j) + ...
	    sumSquareError;
	absErrSumMatrix(i,j) = absErrSumMatrix(i,j) + sumAbsErr;
	totalCount(i,j) = totalCount(i,j) + n;

	alltrial_squaredErrorSumMatrix(i,j) = ...
	    alltrial_squaredErrorSumMatrix(i,j) + sumSquareError;
	alltrial_absErrSumMatrix(i,j) = alltrial_absErrSumMatrix(i,j) + ...
	    sumAbsErr;
	alltrial_count = alltrial_count +n;

	fname = ['~/Documents/cs229/ourdata/' dataset '/knn/' ...
		 rhythmname '-knn-k' num2str(k) '-tau' num2str(tau) '.MID'];
	if write_midi_sequences
	  writemidi(nmout(usableIndices,:), fname, 10000, gettempo(nmout));
	  disp(['Wrote midi sequence ' fname])
	else   
	  disp(['DID NOT write midi sequence ' fname])
	end
      end % each tau
    end % each k
  end % each trial

  [trial_bestErrVar  trial_bestTauind trial_bestKind] = ...
      min2d(alltrial_squaredErrorSumMatrix/alltrial_count);
%  correspondingAvgErr = ...
%      alltrial_absErrSumMatrix(trial_bestKind, trial_bestTauind) / ...
%      alltrial_count;

  disp(['Finished all ' num2str(num_trials) ' trials.']);
  disp('name, bestErrVar, k, tau');
  disp([rhythmname ', ' num2str(trial_bestErrVar) ', ' ...
	num2str(kvalues(trial_bestKind)) ', ' ...
	num2str(tauvalues(trial_bestTauind)) ]);


end % each rhythm
end % each genre

kvalues
tauvalues


errVarMatrix = squaredErrorSumMatrix ./ totalCount;
absErrAvgMatrix = absErrSumMatrix ./ totalCount;
errVarMatrix
absErrAvgMatrix


[bestErrVar bestTauind bestKind] = min2d(errVarMatrix);
bestK = kvalues(bestKind);
bestTau = tauvalues(bestTauind);
disp(['Best error variance was ' num2str(bestErrVar) ' for k=' ...
      num2str(bestK) ', tau=' num2str(bestTau)]);
disp(['  STD = sqrt(var) = ' num2str(sqrt(bestErrVar))]);
disp([' Corresponding absErrAvg: ' ...
      num2str(absErrAvgMatrix(bestKind, bestTauind))]);


[bestAbsErrAvg bestTauind bestKind] = min2d(absErrAvgMatrix);
bestK = kvalues(bestKind);
bestTau = tauvalues(bestTauind);
disp(['Best absolute error average was ' num2str(bestAbsErrAvg) ' for k=' ...
      num2str(bestK) ', tau=' num2str(bestTau)]);


% save(['~/Documents/cs229/results/knn-allrhythms.mat']);
disp('Have a nice day!');

disp('Brought to you by LWLR.');
