function simpleStatAnalysis(dataset)

doplot = 1;
global fignum
fignum = 1;

outdir = strcat(dataset,'/Quantized/');

% Load quantized/unquantized data
% 'nm_cell','nmq_cell','fnames','onsetRes'
load(strcat(outdir,'/NoteMatrices.mat'))


% for OLODUN
nm = nm_cell{2};
nmq = nmq_cell{2};
rhythm_name = 'Olodum';

% Global groove template
[g_means, g_stds, pos] = estimateGrooveTemplate(nm, nmq, 'Global (all timbres)');

timbres = unique(nm(:,4))
% for debug:  timbres = [42 62]

num_timbres = length(timbres)

variancePerInstrument = zeros(1, num_timbres);

for i = 1:num_timbres
    singleTimbre = timbres(i);
    disp(['timbre ' num2str(singleTimbre) ': ' timbre_name(singleTimbre)]);
    ind = find(nm(:,4)==singleTimbre);
    if isempty(ind)
       error(['No notes had desired timbre ' num2str(singleTimbre)]);
    end
    hhnm = nm(ind,:);
    hhnmq = nmq(ind,:);
    [means,stds,pos, variancePerInstrument(i)] = ...
       estimateGrooveTemplate(hhnm, hhnmq, [rhythm_name ' ' timbre_name(singleTimbre)]);

    fignum = fignum+1;
    figure(fignum)

    differential = means-g_means;
    ind = find(means==0);
    differential(ind) = zeros(size(ind)) ;

    bar(pos, differential);
    title(['Differential groove template (delta from global) ' ...
          rhythm_name ' ' timbre_name(singleTimbre)]);


end


fignum = fignum+1;
figure(fignum)
bar(timbres, variancePerInstrument);
title(['Total variance for each instrument for ' rhythm_name]);


error('done');

if doplot
fignum = fignum+1;
figure(fignum)
errorbar(pos,means,-stds,stds)
errorbar(pos(1:2:length(pos)),means(1:2:length(pos)),-stds(1:2:length(pos)),stds(1:2:length(pos)))
end

resynthesize = 0;

if resynthesize
    % Resynthesis from mean and variance of groove template
    hhnmsynth = hhnmq;
    tmpo = gettempo(hhnmq);
    for n=1:length(pos),
        ind = find(mod(hhnmsynth(:,1),4) == pos(n));
        L = length(ind);
        changeBeatsBy = means(n)*ones(L,1) + randn(L,1)*stds(n)*1;
        hhnmsynth(ind,1) = hhnmsynth(ind,1) + changeBeatsBy;
        hhnmsynth(ind,6) = hhnmsynth(ind,6) + changeBeatsBy/120*tmpo;
    end
end    
    

if doplot
    fignum = fignum+1;
    figure(fignum)
    pianoroll(hhnm)
    pianoroll(hhnmq,'hold','b')
    pianoroll(hhnmsynth,'hold','g')
end

writemidi(hhnmsynth,'TESTSYNTH.MID',5000,gettempo(hhnmsynth));
