function [name, h] = timbre_name(notenumber, flag)
% Given a timbre (expressed as a MIDI note number), return the name
% (as a string) and Matt's subjective 1D "height" (related to pitch/spectral
% centroid).
%
% flag is optional, and if given, then instead a column vector
% containing all of the timbres in ascending order is output in h

global unusualness totTimb   % from load_data

if (nargin > 1)
    name = [];
    % This was extacted by from Matt's code below
    %h = [35 36 37 38 40 42 44 46 41 43 45 47 48 50 49 51 52 54 55 56 57 58 62 63 64 65 66 67 68 69 70 82 80 81 86 87]';

    % But I came up with another list in estimateunusualness    
    h = totTimb;
    return
end


switch notenumber
  case {36}
       name = 'kick';
       h = .1;
  case 37
       name = 'rimshot';
       h = .4;
  case {38,40}
       name = 'snare';
       h = .5;
  case 42
       name = 'closed-hh';
       h = .7;
  case {44,46}
       name = 'open-hh';
       h = .68;
  case {41,43}
       name = 'tom-low';
       h = .22;
  case {45, 47}
       name = 'tom-mid';
       h = .25;
  case {48, 50}
       name = 'tom-hi';
       h = .28;
  case 49
       name = 'crash';
       h = 1;
  case 51
       name = 'ride';
       h = .75;
  case 52
       name = 'china';
       h = 1;
  case 54
       name = 'tambourine';
       h = .75;
  case 55
       name = 'splash';
       h = .98;
  case 56
       name = 'cowbell';
       h = .6;
  case 57
       name = 'crash-mute';
       h = 1;
  case 58
       name = 'vibraslap';
       h = 1;
  case 62
       name = 'conga-hi-mute';
       h = .35;
  case 63
       name = 'conga-hi';
       h = .33;
  case 64
       name = 'conga-low';
       h = .3;
  case 65
       name = 'repique';
       h = .55;
  case 66
       name = 'repique-low';
       h = .54;
  case 67
       name = 'bell-hi';
       h = .66;
  case 68
       name = 'bell-low';
       h = .65;
  case 69
       name = 'cabasa';
       h = .73;
  case {70, 82}
       name = 'shaker';
       h = .73;
  case 80
      name = 'triangle-open';
      h = .8;
  case 81
      name = 'triangle-mute';
      h = .82;
  case 86
       name = 'surdo-mute';
       h = 0.05;
  case 87
       name = 'surdo-open';
       h = 0;
  otherwise
       name = ['unknown:' int2str(notenumber)];
       h = -10;
end
